/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { Step } from "./Step";
import { StepperOrientation_$type } from "./StepperOrientation";
import { StepperStepType_$type } from "./StepperStepType";
import { Direction_$type } from "./Direction";
import { StepperTitlePosition_$type } from "./StepperTitlePosition";
import { ActiveStepChangingArgsEventArgs } from "./ActiveStepChangingArgsEventArgs";
import { ActiveStepChangedArgsEventArgs } from "./ActiveStepChangedArgsEventArgs";
/**
 * @hidden
 */
export let Stepper = /*@__PURE__*/ (() => {
    class Stepper extends BaseElement {
        constructor() {
            super(...arguments);
            this.h = new WCNativeHelper();
            this.l = null;
            this.activeStepChanging = null;
            this.activeStepChanged = null;
        }
        get i() {
            return this.h;
        }
        get nativeElement() {
            return this.l;
        }
        set nativeElement(a) {
            this.l = a;
            this.h.o = this.l;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.i.m("steps", (a) => new Step());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.i.v("steps", value_);
        }
        get e() {
            let ret_ = this.i.n("orientation");
            ret_ = enumGetBox(StepperOrientation_$type, EnumUtil.getEnumValue(StepperOrientation_$type, this.i.f(StepperOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(StepperOrientation_$type, ret_);
        }
        set e(a) {
            let value_ = enumGetBox(StepperOrientation_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.i.v("orientation", value_);
        }
        get f() {
            let ret_ = this.i.n("stepType");
            ret_ = enumGetBox(StepperStepType_$type, EnumUtil.getEnumValue(StepperStepType_$type, this.i.f(StepperStepType_$type, ret_)));
            return EnumUtil.getEnumValue(StepperStepType_$type, ret_);
        }
        set f(a) {
            let value_ = enumGetBox(StepperStepType_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.i.v("stepType", value_);
        }
        get k() {
            let ret_ = this.i.n("linear");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.i.v("linear", value_);
        }
        get j() {
            let ret_ = this.i.n("contentTop");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.i.v("contentTop", value_);
        }
        get d() {
            let ret_ = this.i.n("dir");
            ret_ = enumGetBox(Direction_$type, EnumUtil.getEnumValue(Direction_$type, this.i.f(Direction_$type, ret_)));
            return EnumUtil.getEnumValue(Direction_$type, ret_);
        }
        set d(a) {
            let value_ = enumGetBox(Direction_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.i.v("dir", value_);
        }
        get g() {
            let ret_ = this.i.n("titlePosition");
            ret_ = enumGetBox(StepperTitlePosition_$type, EnumUtil.getEnumValue(StepperTitlePosition_$type, this.i.f(StepperTitlePosition_$type, ret_)));
            return EnumUtil.getEnumValue(StepperTitlePosition_$type, ret_);
        }
        set g(a) {
            let value_ = enumGetBox(StepperTitlePosition_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.i.v("titlePosition", value_);
        }
        activeStepChangingChanged() {
            if (this.activeStepChanging != null) {
                this.i.r("activeStepChanging", (a) => this.activeStepChanging(this, ActiveStepChangingArgsEventArgs.b(a)));
            }
            else {
                this.i.u("activeStepChanging");
            }
        }
        activeStepChangedChanged() {
            if (this.activeStepChanged != null) {
                this.i.r("activeStepChanged", (a) => this.activeStepChanged(this, ActiveStepChangedArgsEventArgs.b(a)));
            }
            else {
                this.i.u("activeStepChanged");
            }
        }
        p() {
            this.nativeElement.connectedCallback();
        }
        q(a) {
            this.nativeElement.navigateTo(this.i.i(a));
        }
        r() {
            this.nativeElement.next();
        }
        s() {
            this.nativeElement.prev();
        }
        t() {
            this.nativeElement.reset();
        }
    }
    Stepper.$t = /*@__PURE__*/ markType(Stepper, 'Stepper', BaseElement.$);
    return Stepper;
})();
