import * as React from 'react';
import { IgrDropdownItem } from "./igr-dropdown-item";
import { SelectItem } from "./SelectItem";
import { IgcSelectItemComponent, defineComponents } from "igniteui-webcomponents";
/**
 * Represents an item in a select list.
*/
export class IgrSelectItem extends IgrDropdownItem {
    createImplementation() {
        return new SelectItem();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._getMainRef = this._getMainRef.bind(this);
        defineComponents(IgcSelectItemComponent);
    }
    componentDidMount() {
        this.i.nativeElement = this._elRef;
        super.componentDidMount();
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        React.Children.forEach(propChildren, (ch) => {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        let style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        let div = React.createElement("igc-select-item", {
            ref: this._getMainRef,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    }
    _getMainRef(ref) {
        this._elRef = ref;
    }
    /**
     * Sets the textContent of the item without touching the prefix and suffix content.
    */
    get textContent() {
        return this.i.k;
    }
    set textContent(v) {
        this.i.k = v;
    }
}
