import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { TreeItem as TreeItem_internal } from './TreeItem';
import { IgrTreeItem as IgrTreeItem } from './igr-tree-item';
export class IgrTreeItemCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrTreeItem.$type) {
            IgrTreeItem.$type = markType(IgrTreeItem, "IgrTreeItem");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrTreeItem.$type) {
            IgrTreeItem.$type = markType(IgrTreeItem, "IgrTreeItem");
        }
        let coll = new SyncableObservableCollection$2(IgrTreeItem.$type, TreeItem_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrTreeItem._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
