import { IgrDockManagerPane } from "./igr-dock-manager-pane";
import { PaneCloseEventArgsDetail as PaneCloseEventArgsDetail_internal } from "./PaneCloseEventArgsDetail";
import { IgrContentPane } from "./igr-content-pane";
var IgrPaneCloseEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrPaneCloseEventArgsDetail() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPaneCloseEventArgsDetail.prototype.createImplementation = function () {
        return new PaneCloseEventArgsDetail_internal();
    };
    Object.defineProperty(IgrPaneCloseEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPaneCloseEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrPaneCloseEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPaneCloseEventArgsDetail.prototype, "sourcePane", {
        /**
         * Get the source pane that triggers the close.
        */
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrDockManagerPane._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPaneCloseEventArgsDetail.prototype, "panes", {
        /**
         * Gets/sets the panes that are about to close.
        */
        get: function () {
            if (!this.i.a) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.a.length; i++) {
                var impl = this.i.a[i];
                if (!impl.externalObject) {
                    if (impl instanceof IgrContentPane) {
                        ret.push(impl);
                        continue;
                    }
                    var e = IgrContentPane._createFromInternal(impl);
                    e._implementation = impl;
                    impl.externalObject = e;
                }
                ret.push(impl.externalObject);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i].i);
            }
            this.i.a = arr;
        },
        enumerable: false,
        configurable: true
    });
    IgrPaneCloseEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.sourcePane && this.sourcePane.name && this.sourcePane.name == name) {
            return this.sourcePane;
        }
        return null;
    };
    IgrPaneCloseEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrPaneCloseEventArgsDetail;
}());
export { IgrPaneCloseEventArgsDetail };
