import { IgrDockManagerPane } from "./igr-dock-manager-pane";
import { IgrPaneDragAction } from "./igr-pane-drag-action";
import { PaneDragOverEventArgsDetail as PaneDragOverEventArgsDetail_internal } from "./PaneDragOverEventArgsDetail";
import { IgrContentPane } from "./igr-content-pane";
import { ensureBool } from "igniteui-react-core";
var IgrPaneDragOverEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrPaneDragOverEventArgsDetail() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPaneDragOverEventArgsDetail.prototype.createImplementation = function () {
        return new PaneDragOverEventArgsDetail_internal();
    };
    Object.defineProperty(IgrPaneDragOverEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPaneDragOverEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrPaneDragOverEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPaneDragOverEventArgsDetail.prototype, "sourcePane", {
        /**
         * Gets the source pane that triggers the drag over.
        */
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrDockManagerPane._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPaneDragOverEventArgsDetail.prototype, "panes", {
        /**
         * Gets the panes that are dragged over.
        */
        get: function () {
            if (!this.i.a) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.a.length; i++) {
                var impl = this.i.a[i];
                if (!impl.externalObject) {
                    if (impl instanceof IgrContentPane) {
                        ret.push(impl);
                        continue;
                    }
                    var e = IgrContentPane._createFromInternal(impl);
                    e._implementation = impl;
                    impl.externalObject = e;
                }
                ret.push(impl.externalObject);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i].i);
            }
            this.i.a = arr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPaneDragOverEventArgsDetail.prototype, "action", {
        /**
         * Gets information about the action being performed.
        */
        get: function () {
            var r = this.i.c;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPaneDragAction({});
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.c = null : this.i.c = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPaneDragOverEventArgsDetail.prototype, "isValid", {
        /**
         * Gets/sets whether the action is valid.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrPaneDragOverEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.sourcePane && this.sourcePane.name && this.sourcePane.name == name) {
            return this.sourcePane;
        }
        if (this.action && this.action.name && this.action.name == name) {
            return this.action;
        }
        return null;
    };
    IgrPaneDragOverEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrPaneDragOverEventArgsDetail;
}());
export { IgrPaneDragOverEventArgsDetail };
