import * as React from 'react';
import { Accordion } from "./Accordion";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * The Accordion is a container-based component that can house multiple expansion panels
 * and offers keyboard navigation.
*/
export declare class IgrAccordion<P extends IIgrAccordionProps = IIgrAccordionProps> extends React.Component<P, {}> {
    protected createImplementation(): Accordion;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Accordion; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrAccordion;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Allows only one panel to be expanded at a time.
    */
    get singleExpand(): boolean;
    set singleExpand(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    /**
     * Hides all of the child expansion panels' contents.
    
    */
    hideAll(): void;
    /**
     * Shows all of the child expansion panels' contents.
    
    */
    showAll(): void;
}
export interface IIgrAccordionProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Allows only one panel to be expanded at a time.
    */
    singleExpand?: boolean | string;
}
