import * as React from 'react';
import { BadgeVariant } from "./BadgeVariant";
import { BadgeShape } from "./BadgeShape";
import { Badge } from "./Badge";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * The badge is a component indicating a status on a related item or an area
 * where some active indication is required.
*/
export declare class IgrBadge<P extends IIgrBadgeProps = IIgrBadgeProps> extends React.Component<P, {}> {
    protected createImplementation(): Badge;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Badge; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrBadge;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The type of badge.
    */
    get variant(): BadgeVariant;
    set variant(v: BadgeVariant);
    /**
     * Sets whether to draw an outlined version of the badge.
    */
    get outlined(): boolean;
    set outlined(v: boolean);
    /**
     * The shape of the badge.
    */
    get shape(): BadgeShape;
    set shape(v: BadgeShape);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrBadgeProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * The type of badge.
    */
    variant?: BadgeVariant | string;
    /**
     * Sets whether to draw an outlined version of the badge.
    */
    outlined?: boolean | string;
    /**
     * The shape of the badge.
    */
    shape?: BadgeShape | string;
}
