import * as React from 'react';
import { CalendarBaseSelection } from "./CalendarBaseSelection";
import { CalendarBaseWeekStart } from "./CalendarBaseWeekStart";
import { CalendarBase } from "./CalendarBase";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
import { IDateRangeDescriptor } from "./IDateRangeDescriptor";
export declare class IgrCalendarBase<P extends IIgrCalendarBaseProps = IIgrCalendarBaseProps> extends React.Component<P, {}> {
    protected createImplementation(): CalendarBase;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): CalendarBase; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrCalendarBase;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Sets the type of date selection.
    */
    get selection(): CalendarBaseSelection;
    set selection(v: CalendarBaseSelection);
    /**
     * Show/hide the week numbers.
    */
    get showWeekNumbers(): boolean;
    set showWeekNumbers(v: boolean);
    /**
     * Sets the start day of the week.
    */
    get weekStart(): CalendarBaseWeekStart;
    set weekStart(v: CalendarBaseWeekStart);
    /**
     * Sets the locale used for formatting and displaying the dates in the calendar.
    */
    get locale(): string;
    set locale(v: string);
    /**
     * Gets/sets disabled dates.
    */
    get disabledDates(): IDateRangeDescriptor[];
    set disabledDates(v: IDateRangeDescriptor[]);
    /**
     * Gets/sets special dates.
    */
    get specialDates(): IDateRangeDescriptor[];
    set specialDates(v: IDateRangeDescriptor[]);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrCalendarBaseProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Sets the type of date selection.
    */
    selection?: CalendarBaseSelection | string;
    /**
     * Show/hide the week numbers.
    */
    showWeekNumbers?: boolean | string;
    /**
     * Sets the start day of the week.
    */
    weekStart?: CalendarBaseWeekStart | string;
    /**
     * Sets the locale used for formatting and displaying the dates in the calendar.
    */
    locale?: string;
    /**
     * Gets/sets disabled dates.
    */
    disabledDates?: IDateRangeDescriptor[];
    /**
     * Gets/sets special dates.
    */
    specialDates?: IDateRangeDescriptor[];
}
