import * as React from 'react';
import { LinearProgressLabelAlign } from "./LinearProgressLabelAlign";
import { IgrProgressBase, IIgrProgressBaseProps } from "./igr-progress-base";
import { LinearProgress } from "./LinearProgress";
/**
 * A linear progress indicator used to express unspecified wait time or display
 * the length of a process.
*/
export declare class IgrLinearProgress extends IgrProgressBase<IIgrLinearProgressProps> {
    protected createImplementation(): LinearProgress;
    /**
                                 * @hidden
                                 */
    get i(): LinearProgress;
    constructor(props: IIgrLinearProgressProps);
    componentDidMount(): void;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: string;
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Sets the striped look of the control.
    */
    get striped(): boolean;
    set striped(v: boolean);
    /**
     * The position for the default label of the control.
    */
    get labelAlign(): LinearProgressLabelAlign;
    set labelAlign(v: LinearProgressLabelAlign);
}
export interface IIgrLinearProgressProps extends IIgrProgressBaseProps {
    /**
     * Sets the striped look of the control.
    */
    striped?: boolean | string;
    /**
     * The position for the default label of the control.
    */
    labelAlign?: LinearProgressLabelAlign | string;
}
