import * as React from 'react';
import { RadioGroupAlignment } from "./RadioGroupAlignment";
import { RadioGroup } from "./RadioGroup";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrRadioGroup<P extends IIgrRadioGroupProps = IIgrRadioGroupProps> extends React.Component<P, {}> {
    protected createImplementation(): RadioGroup;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): RadioGroup; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrRadioGroup;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Alignment of the radio controls inside this group.
    */
    get alignment(): RadioGroupAlignment;
    set alignment(v: RadioGroupAlignment);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrRadioGroupProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Alignment of the radio controls inside this group.
    */
    alignment?: RadioGroupAlignment | string;
}
