import * as React from 'react';
import { SelectDir } from "./SelectDir";
import { IgrVoidEventArgs } from "./igr-void-event-args";
import { IgrFocusOptions } from "./igr-focus-options";
import { IgrDropdown, IIgrDropdownProps } from "./igr-dropdown";
import { Select } from "./Select";
export declare class IgrSelect extends IgrDropdown<IIgrSelectProps> {
    protected createImplementation(): Select;
    /**
                                 * @hidden
                                 */
    get i(): Select;
    constructor(props: IIgrSelectProps);
    componentDidMount(): void;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: string;
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The value attribute of the control.
    */
    get value(): string;
    set value(v: string);
    /**
     * The name attribute of the control.
    */
    get name(): string;
    set name(v: string);
    /**
     * The disabled attribute of the control.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    /**
     * The required attribute of the control.
    */
    get required(): boolean;
    set required(v: boolean);
    /**
     * The invalid attribute of the control.
    */
    get invalid(): boolean;
    set invalid(v: boolean);
    /**
     * The outlined attribute of the control.
    */
    get outlined(): boolean;
    set outlined(v: boolean);
    /**
     * The autofocus attribute of the control.
    */
    get autofocus(): boolean;
    set autofocus(v: boolean);
    /**
     * The label attribute of the control.
    */
    get label(): string;
    set label(v: string);
    /**
     * The placeholder attribute of the control.
    */
    get placeholder(): string;
    set placeholder(v: string);
    /**
     * The direction attribute of the control.
    */
    get dir(): SelectDir;
    set dir(v: SelectDir);
    /**
     * Sets focus on the component.
    
    */
    focusComponent(options: IgrFocusOptions): void;
    /**
     * Removes focus from the component.
    
    */
    blurComponent(): void;
    /**
     * Checks the validity of the control and moves the focus to it if it is not valid.
    
    */
    reportValidity(): void;
    /**
     * Checks the validity of the control.
    
    */
    checkValidity(): void;
    private _focus;
    private _focus_wrapped;
    get focus(): (s: IgrSelect, e: IgrVoidEventArgs) => void;
    set focus(ev: (s: IgrSelect, e: IgrVoidEventArgs) => void);
    private _blur;
    private _blur_wrapped;
    get blur(): (s: IgrSelect, e: IgrVoidEventArgs) => void;
    set blur(ev: (s: IgrSelect, e: IgrVoidEventArgs) => void);
}
export interface IIgrSelectProps extends IIgrDropdownProps {
    /**
     * The value attribute of the control.
    */
    value?: string;
    /**
     * The name attribute of the control.
    */
    name?: string;
    /**
     * The disabled attribute of the control.
    */
    disabled?: boolean | string;
    /**
     * The required attribute of the control.
    */
    required?: boolean | string;
    /**
     * The invalid attribute of the control.
    */
    invalid?: boolean | string;
    /**
     * The outlined attribute of the control.
    */
    outlined?: boolean | string;
    /**
     * The autofocus attribute of the control.
    */
    autofocus?: boolean | string;
    /**
     * The label attribute of the control.
    */
    label?: string;
    /**
     * The placeholder attribute of the control.
    */
    placeholder?: string;
    /**
     * The direction attribute of the control.
    */
    dir?: SelectDir | string;
    focus?: (s: IgrSelect, e: IgrVoidEventArgs) => void;
    blur?: (s: IgrSelect, e: IgrVoidEventArgs) => void;
}
