import * as React from 'react';
import { DockManagerPaneType } from "./DockManagerPaneType";
import { IgrContentPaneCollection } from "./igr-content-pane-collection";
import { IgrDockManagerPane, IIgrDockManagerPaneProps } from "./igr-dock-manager-pane";
import { TabGroupPane } from "./TabGroupPane";
export declare class IgrTabGroupPane extends IgrDockManagerPane<IIgrTabGroupPaneProps> {
    protected createImplementation(): TabGroupPane;
    /**
                                 * @hidden
                                 */
    get i(): TabGroupPane;
    constructor(props: IIgrTabGroupPaneProps);
    componentDidMount(): void;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: string;
        style: {};
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The id of the pane. If not set the Dock Manager generates it automatically.
    */
    get id(): string;
    set id(v: string);
    /**
     * The type of the pane.
    */
    get type(): DockManagerPaneType;
    set type(v: DockManagerPaneType);
    private _panes;
    /**
     * The child content panes of the tab group.
    */
    get panes(): IgrContentPaneCollection;
    set panes(v: IgrContentPaneCollection);
    /**
     * The size of the pane relative to its sibling panes' sizes. Defaults to 100.
    */
    get size(): number;
    set size(v: number);
    /**
     * The index of the selected tab.
    */
    get selectedIndex(): number;
    set selectedIndex(v: number);
    /**
     * Determines whether the pane should present in the UI when empty.
    */
    get allowEmpty(): boolean;
    set allowEmpty(v: boolean);
    /**
     * Determines whether a tab group is maximized or not. Defaults to false.
    */
    get isMaximized(): boolean;
    set isMaximized(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
export interface IIgrTabGroupPaneProps extends IIgrDockManagerPaneProps {
    /**
     * The id of the pane. If not set the Dock Manager generates it automatically.
    */
    id?: string;
    /**
     * The type of the pane.
    */
    type?: DockManagerPaneType | string;
    /**
     * The size of the pane relative to its sibling panes' sizes. Defaults to 100.
    */
    size?: number | string;
    /**
     * The index of the selected tab.
    */
    selectedIndex?: number | string;
    /**
     * Determines whether the pane should present in the UI when empty.
    */
    allowEmpty?: boolean | string;
    /**
     * Determines whether a tab group is maximized or not. Defaults to false.
    */
    isMaximized?: boolean | string;
}
