import * as React from 'react';
import { IgrFocusOptions } from "./igr-focus-options";
import { Tab } from "./Tab";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Represents the tab header.
*/
export declare class IgrTab<P extends IIgrTabProps = IIgrTabProps> extends React.Component<P, {}> {
    protected createImplementation(): Tab;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Tab; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrTab;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The id of the tab panel which will be controlled by the tab.
    */
    get panel(): string;
    set panel(v: string);
    /**
     * Determines whether the tab is selected.
    */
    get selected(): boolean;
    set selected(v: boolean);
    /**
     * Determines whether the tab is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    connectedCallback(): void;
    /**
     * Sets focus to the tab.
    
    */
    focus(options: IgrFocusOptions): void;
    /**
     * Removes focus from the tab.
    
    */
    blur(): void;
}
export interface IIgrTabProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * The id of the tab panel which will be controlled by the tab.
    */
    panel?: string;
    /**
     * Determines whether the tab is selected.
    */
    selected?: boolean | string;
    /**
     * Determines whether the tab is disabled.
    */
    disabled?: boolean | string;
}
